(defun c:an ()

  (setq first      nil
        second     nil
        point_list nil
  )
  (setq selset (LM:ssget "\nSelect the first entity: " '("_+.:S:L" ((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")))))
  (while (= selset nil)
    (setq selset (LM:ssget "\nNothing selected.  Select the first entity: " '("_+.:S:L" ((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")))))
  )
  (setq ename1 (ssnamex selset 0)
        point1 (cadr (cadddr (car ename1)))
        ename1 (cadr (car ename1))
        point1 (vlax-curve-getclosestpointto ename1 point1)
  )
  (setq selset (LM:ssget "\nSelect the second entity: " '("_+.:S:L" ((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")))))
  (while (= selset nil)
    (setq selset (LM:ssget "\nNothing selected.  Select the second entity: " '("_+.:S:L" ((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")))))
  )
  (setq ename2 (ssnamex selset 0)
        point2 (cadr (cadddr (car ename2)))
        ename2 (cadr (car ename2))
        point2 (vlax-curve-getclosestpointto ename2 point2)
        point3 (vle-vector-midpoint  point1  point2)
  )
  (if (setq intersection_data (vlax-invoke (vlax-ename->vla-object ename1) 'IntersectWith (vlax-ename->vla-object ename2) 0))
    (repeat (/ (length intersection_data) 3)
      (setq point_list (cons (list (car intersection_data)
                                   (cadr intersection_data)
                                   (caddr intersection_data)
                             )
                             point_list
                       )
            intersection_data (cdddr intersection_data)
      )
    )
  )
  (setq point_list (vl-sort point_list '(lambda (a b) (< (distance point3 a) (distance point3 b)))))
  (setq point4 (car point_list))
  (setq object1 (vlax-ename->vla-object ename1)
        object2 (vlax-ename->vla-object ename2)
  )
  (setq parameter (cond (  (equal point4 (vlax-curve-getStartPoint object1) 1e-5)
                              (vlax-curve-getStartParam object1)
                        )
                        (  (equal point4 (vlax-curve-getEndPoint object1) 1e-5)
                                (vlax-curve-getEndParam object1)
                        )
                        (  (setq pointb (vlax-curve-getClosestPointTo object1 point4))
                           (if (<= (distance point4 pointb) 1e-5)
                             (vlax-curve-getParamAtPoint object1 pointb)
                           )
                        )
                        (T nil)
                  )
  )
  (if parameter
    (setq angle1 (angle '(0.0 0.0 0.0) (vlax-curve-getfirstderiv ename1 parameter)))
  )
  (setq parameter (cond (  (equal point4 (vlax-curve-getStartPoint object2) 1e-5)
                              (vlax-curve-getStartParam object2)
                        )
                        (  (equal point4 (vlax-curve-getEndPoint object2) 1e-5)
                                (vlax-curve-getEndParam object2)
                        )
                        (  (setq pointb (vlax-curve-getClosestPointTo object2 point4))
                           (if (<= (distance point4 pointb) 1e-5)
                             (vlax-curve-getParamAtPoint object2 pointb)
                           )
                        )
                        (T nil)
                  )
  )
  (if parameter
    (setq angle2 (angle '(0.0 0.0 0.0) (vlax-curve-getfirstderiv ename2 parameter)))
  )
  (setq angle3 (+ angle1 pi)
        angle4 (+ angle2 pi)
  )
  (if (> angle3 (+ pi pi))
    (setq angle3 (- angle3 (+ pi pi)))
  )
  (if (> angle4 (+ pi pi))
    (setq angle4 (- angle4 (+ pi pi)))
  )
  (setq angles (list angle1 angle2 angle3 angle4))
  (setq angles (vl-sort angles '(lambda (a b) (> a b))))
  (setq angle5 (angle point4 point3))
  (cond ( (> angle5 (nth 0 angles))
            (setq result (- (+ (nth 3 angles) pi pi) (nth 0 angles)))
        )
        ( (> angle5 (nth 1 angles))
            (setq result (- (nth 0 angles) (nth 1 angles)))
        )
        ( (> angle5 (nth 2 angles))
            (setq result (- (nth 1 angles) (nth 2 angles)))
        )
        ( (> angle5 (nth 3 angles))
            (setq result (- (nth 2 angles) (nth 3 angles)))
        )
        ( T
            (setq result (- (+ (nth 3 angles) pi pi) (nth 0 angles)))
        )
  )
  (prin (strcat "\n\nAngle:     " (rtos result 2) " Radians     " (rtos (* 180.0 (/ result pi)) 2) " Degrees     " (rtos (* 200.0 (/ result pi)) 2) " Gradients"))
  (princ)
)
